% EZRFs4DayComp  Called by EZmDayComp.m
% For this multiDay Exp series the actual perturbation being studied is
% Aging as related in the time series experiment i.e.,(nn) or DexpN
% That is holding the DrugMedia pert constant(at the DM slider number) and plotting
RFconfig=Exp(zoneSel).Dexp(DexpN).RFconfig;
RFsel=Exp(zoneSel).htmapRFanswer;
j=pertSel; m=MPsel;
if RFconfig==1
  try
    RF1mdIndx(nn)=Exp(zoneSel).Dexp(nn).RFmd1indx(pertSel);
    RF1mdPltN(nn)=Exp(zoneSel).Dexp(nn).RFmd1pltN; %This is the MP number for RF1
    RFmdVal(nn)=Exp(zoneSel).Dexp(nn).RFmd1val(pertSel);
  catch, end
  try
    RF2mdIndx(nn)=Exp(zoneSel).Dexp(nn).RFmd2indx(pertSel);
    RF2mdPltN(nn)=Exp(zoneSel).Dexp(nn).RFmd2pltN;
    % special case for 'RFmd2val' See Calc. at EZmDayComp ~ln139 
  catch, end
  try Rn(nn)=Exp(expN).Dexp(nn).RFmean(pertSel); catch, Rn(nn)=0; end
  try Rs(nn)=Exp(expN).Dexp(nn).RFstd(pertSel); catch, Rs(nn)=0; end
end
if RFconfig==2
  ctrlRF=RFsel{1};
  j=pertSel; m=MPsel;
  switch ctrlRF
    case {'G','g'}
      % Set to (nn) day as these median values are being plotted directly    
      RFmdIndx(nn)=Exp(zoneSel).Dexp(nn).RFmdGindx(pertSel);
      RFmdPltN(nn)=Exp(zoneSel).Dexp(nn).RFmdGpltN(pertSel); %G could have a different MP for each DM;At any rate it is stored for each DM regardless.
      RFmdVal(nn)=Exp(zoneSel).Dexp(nn).RFmedianG(pertSel);
      % Set mean values to Day 1 as these are used in Interaction Calc.
      % as the first reference ctrlRF 'Aging Perturbation'  
      Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(pertSel);
      Rs(nn)=Exp(expN).Dexp(nn).RFstdG(pertSel);
    case {'L','l'}
      % Set to (nn) day as these median values are being plotted directly        
      RFmdVal(nn)=Exp(zoneSel).Dexp(nn).RFmedianP(pertSel);
      % Set mean values to Day 1 as these are used in Interaction Calc.
      % as the first reference ctrlRF 'Aging Perturbation'
      if Exp(expN).Dexp(nn).meanP(j,m)~=0    
        Rn(nn)=Exp(expN).Dexp(nn).meanP(j,m);
        Rs(nn)=Exp(expN).Dexp(nn).stdP(j,m);
      elseif Exp(expN).Dexp(nn).meanP(j,m)==0||isempty(Exp(expN).Dexp(nn).meanP(j,m)) ...
      && strcmpi(ctrlRF,'G')
        Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(pertSel);
        Rs(nn)=Exp(expN).Dexp(nn).RFstdG(pertSel);
      end
  end
  pertRF=RFsel{2}; % These results are only used for N2 future Interaction Calc.
  % nn is ordered number of the selected chronological day Experiment
  % In the chronological study, Age (day sequence results) is the
  % 'Perturbation' of interest instead of DrugMedia concentration.
  switch pertRF
    case {'G','g'}
      Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(pertSel);
      Rs(nn)=Exp(expN).Dexp(nn).RFstdG(pertSel);
    case {'L','l'}
      j=pertSel; m=MPsel;
      if Exp(expN).Dexp(nn).meanP(j,m)~=0    
        Rn(nn)=Exp(expN).Dexp(nn).meanP(j,m);
        Rs(nn)=Exp(expN).Dexp(nn).stdP(j,m);
      elseif Exp(expN).Dexp(nn).meanP(j,m)==0||isempty(Exp(expN).Dexp(nn).meanP(j,m)) ...
      && strcmpi(ctrlRF,'G')
        Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(j);
        Rs(nn)=Exp(expN).Dexp(nn).RFstdG(j);
      end
  end
end

if RFconfig==3
  j=pertSel; m=MPsel;
  ctrlRF=RFsel{1};

 switch ctrlRF
    case {'F','f'}
      try
        RF1mdIndx(nn)=Exp(zoneSel).Dexp(nn).RFmd1indx(pertSel);
        RF1mdPltN(nn)=Exp(zoneSel).Dexp(nn).RFmd1pltN;
        RFmdVal(nn)=Exp(zoneSel).Dexp(nn).RFmd1val(pertSel);
      catch, end
      try
        RF2mdIndx(nn)=Exp(zoneSel).Dexp(nn).RFmd2indx(pertSel);
        RF2mdPltN(nn)=Exp(zoneSel).Dexp(nn).RFmd2pltN(pertSel);
        %special case for 'RFmd2val' See Calc. at EZmDayComp ~ln139 
      catch, end
      try Rn(nn)=Exp(expN).Dexp(nn).RFmean; catch, Rn(nn)=0; end
      try Rs(nn)=Exp(expN).Dexp(nn).RFstd; catch, Rs(nn)=0; end  
        Rn(nn)=Exp(expN).Dexp(nn).RFmean(nn);
        Rs(nn)=Exp(expN).Dexp(nn).RFstd(nn);
    case {'G','g'}
      Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(nn);
      Rs(nn)=Exp(expN).Dexp(nn).RFstdG(nn);
    case {'L','l'}
      Rn(nn)=Exp(expN).Dexp(nn).meanP(j,m);
      Rs(nn)=Exp(expN).Dexp(nn).stdP(j,m);
      if Exp(expN).Dexp(nn).meanP(j,m)~=0  
        Rn(nn)=Exp(expN).Dexp(nn).meanP(j,m);
        Rs(nn)=Exp(expN).Dexp(nn).stdP(j,m);
      elseif Exp(expN).Dexp(nn).meanP(j,m)==0 && strcmpi(ctrlRF,'G')
        Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(j);
        Rs(nn)=Exp(expN).Dexp(nn).RFstdG(j);
      elseif Exp(expN).Dexp(nn).meanP(j,m)==0 && strcmpi(ctrlRF,'F')
        Rn(nn)=Exp(expN).Dexp(nn).RFmean(j);
        Rs(nn)=Exp(expN).Dexp(nn).RFstd(j);
      elseif Exp(expN).Dexp(nn).meanP(1,m)==0 && strcmpi(ctrlRF,'L')
        Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(1);
        Rs(nn)=Exp(expN).Dexp(nn).RFstdG(1);   
      end
  end
  pertRF=RFsel{2};
  switch pertRF
    case {'F','f'}
      Rn(nn)=Exp(expN).Dexp(nn).RFmean(pertSel);
      Rs(nn)=Exp(expN).Dexp(nn).RFstd(pertSel);
    case {'G','g'}
      Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(pertSel);
      Rs(nn)=Exp(expN).Dexp(nn).RFstdG(pertSel);
    case {'L','l'}
      if Exp(expN).Dexp(nn).meanP(j,m)~=0,    
        Rn(nn)=Exp(expN).Dexp(nn).meanP(j,m);
        Rs(nn)=Exp(expN).Dexp(nn).stdP(j,m);
      elseif Exp(expN).Dexp(nn).meanP(j,m)==0 && strcmpi(ctrlRF,'G')
        Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(j);
        Rs(nn)=Exp(expN).Dexp(nn).RFstdG(j);
      elseif Exp(expN).Dexp(nn).meanP(j,m)==0 && strcmpi(ctrlRF,'F')
        Rn(nn)=Exp(expN).Dexp(nn).RFmean(j);
        Rs(nn)=Exp(expN).Dexp(nn).RFstd(j);
      elseif Exp(expN).Dexp(nn).meanP(j,m)==0 && strcmpi(ctrlRF,'L')
        Rn(nn)=Exp(expN).Dexp(nn).RFmeanG(j);
        Rs(nn)=Exp(expN).Dexp(nn).RFstdG(j);   
      end
  end
end
