function varargout = EZviewGui(varargin)
% EZVIEWGUI MATLAB code for EZviewGui.fig
%      EZVIEWGUI, by itself, creates a new EZVIEWGUI or raises the existing
%      singleton*.
%
%      H=EZVIEWGUI returns the handle to a new EZVIEWGUI or the handle to
%      the existing singleton*.
%
%      EZVIEWGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EZVIEWGUI.M with the given input arguments.
%
%      EZVIEWGUI('Property','Value',...) creates a new EZVIEWGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before EZviewGui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to EZviewGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

  gui_Singleton=0;
  gui_State=struct( ...
    'gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @EZviewGui_OpeningFcn, ...
    'gui_OutputFcn',  @EZviewGui_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);

  if nargin && ischar(varargin{1})
    gui_State.gui_Callback=str2func(varargin{1});
  end

  if nargout
    [varargout{1:nargout}]=gui_mainfcn(gui_State, varargin{:});
  else
    try
      gui_mainfcn(gui_State, varargin{:});
    catch
    end
  end
end

% Executes just before EZviewGui is made visible.
function EZviewGui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to EZviewGui (see VARARGIN)

  % Choose default command line output for EZviewGui
  handles.output=hObject;

  % Update handles structure
  guidata(hObject, handles);

  % This sets up the initial plot - only do when we are invisible
  % so window can get raised using EZviewGui.

  if strcmp(get(hObject,'Visible'),'off')
    %plot(rand(5));
  end

  % Special disabling of version for this later install of Matlab 2011a:
  % The ver output changed and no longer works for the simple code that follows
  %{
  % MatLab Version detection
  qv=ver;
  mlver=qv(17).Version
  mlRel=qv(17).Release
  if str2double(mlver)>8.3
    newMLgraph=1
  else
    newMLgraph=0
  end
  %}

  % Load experiment data ....
  EZvInitLoad

  % Func Call setup for @myupdatfcn
  dcm_obj=datacursormode(gcf);
  % datacursormode on;
  set(dcm_obj,'DisplayStyle','window')
  set(dcm_obj,'UpdateFcn', @myupdatefcn);
 
  % UIWAIT makes EZviewGui wait for user response (see UIRESUME)
  % uiwait(handles.figure1);
  % global MPsel
  % MPsel=50;
end

% Outputs from this function are returned to the command line.
function varargout=EZviewGui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Get default command line output from handles structure
  varargout{1}=handles.output;
end

% Menu bar
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
end

function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  file=uigetfile('*.fig');
  if ~isequal(file, 0)
    open(file);
  end
end

function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  printdlg(handles.figure1)
end

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  selection=questdlg(...
    ['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
  if strcmp(selection,'No')
    return;
  end
  delete(handles.figure1);
end

% Executes on mouse press over figure background.
function figure1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
end

% Begin user code
function [output_txt]=myupdatefcn(obj,event_obj)
  global ghandles
  global Exp

  [output_txt]=datatipp(obj,event_obj); % datatipp is a Matlab function
  gcf=Exp(4).guiFig;  % gcf=ghandles.figure1  Mathworks Provided this line for Apple issue
  clkPos=getCursorInfo(datacursormode(gcf));
  cpos=clkPos.Position;
  htargetAxes=clkPos.Target;
  % datacursormode(gcf)
  if ghandles.Iaxes1==get(htargetAxes,'Parent')||...
    ghandles.Iaxes2==get(htargetAxes,'Parent')||...
    ghandles.Iaxes3==get(htargetAxes,'Parent')||... 
    ghandles.OLaxes1==get(htargetAxes,'Parent')||...
    ghandles.OLaxes2==get(htargetAxes,'Parent')||...
    ghandles.OLaxes3==get(htargetAxes,'Parent')||...
    ghandles.HtMap1==get(htargetAxes,'Parent')||...
    ghandles.HtMap2==get(htargetAxes,'Parent')||...
    ghandles.HtMap3==get(htargetAxes,'Parent'),
    EZvDatatip
    %datacursormode off
    %datacursormode on
    %waitforbuttonpress
    %[output_txt]=output_txt;    %datatipp(obj,event_obj);
  end

  prntHt=0; % added 210205 for Print Heatmap buttons [P]
end

% Executes on slider movement.
function MPsldr1_Callback(hObject, eventdata, handles)
% hObject    handle to MPsldr1 (see GCBO)
  global Exp
  expN=1;
  input=floor(get(hObject,'value'));
    display(input)
    set(handles.MPed1,'string',num2str(round(input)));
    EZVimDisplay
 
  % Executes during object creation, after setting all properties.
  %{
  %Migration edits 230814
  function MPsldr1_CreateFcn(hObject, eventdata, handles)
    % Hint: slider controls usually have a light gray background.
    if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
      set(hObject,'BackgroundColor',[.9 .9 .9]);
    end
  end
  %}
end

function MPed1_Callback(hObject, eventdata, handles)
  % hObject    handle to MPed1 (see GCBO)
  global Exp
  global zonePB
  global ghandles

  expN=1;
  zonePB=expN;
  input=get(hObject,'String');
  Max=floor(get(handles.MPsldr1,'max'));
  Min=floor(get(handles.MPsldr1,'min'));
  if str2num(input) >=Min && str2num(input) <=Max
    display(input)
    set(handles.MPsldr1,'value',str2double(input));
  else
    if str2double(input) >=Max, set(handles.MPsldr1,'value',Max); set(handles.MPed1,'string',num2str(Max));end
    if str2double(input) <=Min, set(handles.MPsldr1,'value',Min),set(handles.MPed1,'string',num2str(Min));end
  end  
  EZVimDisplay

  ghandles.guiFig=gcf;
  Exp(4).guiFig=gcf;
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end

  % Executes during object creation, after setting all properties.
  %{
  function MPed1_CreateFcn(hObject, eventdata, handles)
    global ghandles
    global Exp
    ghandles.guiFig=gcf;
    Exp(4).guiFig=gcf;
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
      set(hObject,'BackgroundColor','white');
    end
  end
  %}
end

% Executes on slider movement.
function DMsldr1_Callback(hObject, eventdata, handles)
% hObject    handle to DMsldr1 (see GCBO)
  global Exp
  expN=1;
  input=floor(get(hObject,'value'));
  display(input)
  set(handles.DMed1,'string',num2str(round(input)));
  EZVimDisplay
     
  % Executes during object creation, after setting all properties.
  %{
  function DMsldr1_CreateFcn(hObject, eventdata, handles)
  % hObject    handle to DMsldr1 (see GCBO)
    global Exp
    if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor',[.9 .9 .9]);
    end
  end
  %}
end


function DMed1_Callback(hObject, eventdata, handles)
% hObject    handle to DMed1 (see GCBO)
  global Exp
  expN=1;
  Max=floor(get(handles.DMsldr1,'max'));
  Min=floor(get(handles.DMsldr1,'min'));
  input=get(hObject,'String')
  if str2num(input) >=Min && str2num(input) <=Max
    display(input)
    set(handles.DMsldr1,'value',str2double(input))
  else
    if str2num(input) >=Max, set(handles.DMsldr1,'value',Max); set(handles.DMed1,'string',num2str(Max));end
    if str2num(input) <=Min, set(handles.DMsldr1,'value',Min),set(handles.DMed1,'string',num2str(Min));end
  end  
  EZVimDisplay
end

% Executes during object creation, after setting all properties.
function DMed1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DMed1 (see GCBO)
  % See ISPC and COMPUTER.
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end

% Executes on slider movement.
function Tptsldr1_Callback(hObject, eventdata, handles)
  % hObject    handle to Tptsldr1 (see GCBO)
  global Exp
  expN=1;
  input=floor(get(hObject,'value'));
    display(input)
    set(handles.Tpted1,'string',num2str(floor(input)))
    prntHt=0;
    EZVimDisplay 

  % Executes during object creation, after setting all properties.
  %{
  function Tptsldr1_CreateFcn(hObject, eventdata, handles)
  % hObject    handle to Tptsldr1 (see GCBO)
    if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor',[.9 .9 .9]);
    end
  end
  %}
end

function Tpted1_Callback(hObject, eventdata, handles)
% hObject    handle to Tpted1 (see GCBO)
  global Exp
  expN=1;
  input=get(hObject,'String')
  Max=floor(get(handles.Tptsldr1,'max'));
  Min=floor(get(handles.Tptsldr1,'min'));
  if str2double(input) >=Min && str2double(input) <=Max
    display(input)
    set(handles.Tptsldr1,'value',str2double(input))
  else
    if str2num(input) >=Max, set(handles.Tptsldr1,'value',Max); set(handles.Tpted1,'string',num2str(Max));end
    if str2num(input) <=Min, set(handles.Tptsldr1,'value',Min),set(handles.Tpted1,'string',num2str(Min));end
  end  
  EZVimDisplay
end

% Executes during object creation, after setting all properties.
function Tpted1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tpted1 (see GCBO)
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
  %}
end

% Executes on button press in expSelPB1.
function expSelPB1_Callback(hObject, eventdata, handles)
% hObject    handle to expSelPB1 (see GCBO)
  global Exp
  expN=1; 
  prntHt=0;
  EZexpSel
end

% Executes on button press in rotPB1.
function rotPB1_Callback(hObject, eventdata, handles)
% hObject    handle to rotPB1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  global ghandles
  ghandles=handles;
end

% Executes on button press in clrOlay1.
function clrOlay1_Callback(hObject, eventdata, handles)
% hObject    handle to clrOlay1 (see GCBO)
  global Exp
  global ghandles

  set(ghandles.OLay1,'string',{' '})
  set(ghandles.OLexp1,'string',{''})
  cla(ghandles.OLaxes1)
  Exp(1).traceN=0;
  %Exp(1).cTraceN=0; 
  Exp(1).hOL=[]; Exp(1).hOLb=[];
  Exp(1).hOLname={}; Exp(1).hOLexpNm={}; Exp(1).hOLresDir={};
  Exp(1).hOLplateNum=[];
  Exp(1).hOLresDir={};
  cla(ghandles.Dlaxes1); cla(ghandles.Dkaxes1); cla(ghandles.Draxes1);
  cla(ghandles.DNLaxes1);
  Exp(1).hL =[]; Exp(1).hLb=[];
  Exp(1).hLRF1=[]; Exp(1).hLRF2=[];
  Exp(1).hK =[]; Exp(1).hKb=[];
  Exp(1).hKRF1=[]; Exp(1).hKRF2=[];
  Exp(1).hr =[]; Exp(1).hrb=[];
  Exp(1).rRF1=[]; Exp(1).hrRF2=[];
  Exp(1).hintL =[]; Exp(1).hintLb=[]; % 2016_0222
  Exp(1).hintLadj =[]; Exp(1).hintLadjb=[]; % 2016_0222

  % reset Composite Overlay plot to initialization values
  Exp(1).cTraceN=1;
  Exp(1).ll=[]; Exp(1).rr=[]; Exp(1).kk=[];
  Exp(1).cLmean=[]; Exp(1).cRmean=[]; Exp(1).cKmean=[];
  Exp(1).cTraceIndx=1;
  Exp(1).hCmean=[];
  Exp(1).hBound1=[];
  Exp(1).hBound2=[];
  Exp(1).CompositPlot=0;
  Exp(1).Trace=[];  %added for Trend BoxPlot data 17_1114
end

% Executes on slider movement.
function MPsldr2_Callback(hObject, eventdata, handles)
% hObject    handle to MPsldr2 (see GCBO)
  global Exp
  expN=2;
  input=floor(get(hObject,'value'));
    display(input)
    set(handles.MPed2,'string',num2str(round(input)));
    EZVimDisplay
end

% Executes during object creation, after setting all properties.
%{
%Migration edits 230814
function MPsldr2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to MPsldr2 (see GCBO)
  if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
      set(hObject,'BackgroundColor',[.9 .9 .9]);
  end
end
%}

function MPed2_Callback(hObject, eventdata, handles)
% hObject    handle to MPed2 (see GCBO)
  global Exp
  global zonePB
  global ghandles

  expN=2;
  zonePB=expN;
  input=get(hObject,'String');
  Max=floor(get(handles.MPsldr2,'max'));
  Min=floor(get(handles.MPsldr2,'min'));
  if str2num(input) >=Min && str2num(input) <=Max
  display(input)
  set(handles.MPsldr2,'value',str2double(input));
  else
  if str2num(input) >=Max, set(handles.MPsldr2,'value',Max); set(handles.MPed2,'string',num2str(Max));end
  if str2num(input) <=Min, set(handles.MPsldr2,'value',Min),set(handles.MPed2,'string',num2str(Min));end
  end  
  EZVimDisplay
  ghandles.guiFig=gcf;
  Exp(4).guiFig=gcf;
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end


% Executes during object creation, after setting all properties.
%{
function MPed2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to MPed2 (see GCBO)
  global ghandles
  global Exp
  ghandles.guiFig=gcf;
  Exp(4).guiFig=gcf;
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end
%}


% Executes on slider movement.
function DMsldr2_Callback(hObject, eventdata, handles)
% hObject    handle to DMsldr2 (see GCBO)
  global Exp
  expN=2;
  input=floor(get(hObject,'value'));
    display(input)
    set(handles.DMed2,'string',num2str(round(input)))
    EZVimDisplay
end

% Executes during object creation, after setting all properties.
%{
function DMsldr2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DMsldr2 (see GCBO)
  global Exp
  if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
      set(hObject,'BackgroundColor',[.9 .9 .9]);
  end
end
%}


function DMed2_Callback(hObject, eventdata, handles)
% hObject    handle to DMed2 (see GCBO)
  global Exp
  expN=2;
  Max=floor(get(handles.DMsldr2,'max'));
  Min=floor(get(handles.DMsldr2,'min'));
  input=get(hObject,'String')
  if str2double(input) >=Min && str2double(input) <=Max
    display(input)
    set(handles.DMsldr2,'value',str2double(input))
  else
    if str2double(input) >=Max, set(handles.DMsldr2,'value',Max); set(handles.DMed2,'string',num2str(Max));end
    if str2double(input) <=Min, set(handles.DMsldr2,'value',Min),set(handles.DMed2,'string',num2str(Min));end
  end  
  EZVimDisplay
end


% Executes during object creation, after setting all properties.
function DMed2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DMed2 (see GCBO)
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
  set(hObject,'BackgroundColor','white');
  end
end


% --- Executes on slider movement.
function Tptsldr2_Callback(hObject, eventdata, handles)
% hObject    handle to Tptsldr2 (see GCBO)
  global Exp
  expN=2;
  input=floor(get(hObject,'value'));
    display(input)
    set(handles.Tpted2,'string',num2str(floor(input)))
    prntHt=0;
    EZVimDisplay
end

% --- Executes during object creation, after setting all properties.
%{
function Tptsldr2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tptsldr2 (see GCBO)
  if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
  end
end
%}

function Tpted2_Callback(hObject, eventdata, handles)
% hObject    handle to Tpted2 (see GCBO)
  global Exp
  expN=2;
  input=get(hObject,'String')
  Max=floor(get(handles.Tptsldr2,'max'));
  Min=floor(get(handles.Tptsldr2,'min'));
  if str2double(input) >=Min && str2double(input) <=Max
    display(input)
    set(handles.Tptsldr2,'value',str2double(input))
  else
    if str2num(input) >=Max, set(handles.Tptsldr2,'value',Max); set(handles.Tpted2,'string',num2str(Max));end
    if str2num(input) <=Min, set(handles.Tptsldr2,'value',Min),set(handles.Tpted2,'string',num2str(Min));end
  end  
  EZVimDisplay
end

% Executes during object creation, after setting all properties.
function Tpted2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tpted2 (see GCBO)
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end

% Executes on button press in expSelPB2.
function expSelPB2_Callback(hObject, eventdata, handles)
% hObject    handle to expSelPB2 (see GCBO)
  global Exp
  expN=2;
  prntHt=0;
  EZexpSel
end

% Executes on button press in rotPB2.
function rotPB2_Callback(hObject, eventdata, handles)
% hObject    handle to rotPB2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  global ghandles
  ghandles=handles;
end

% Executes on button press in clrOlay2.
function clrOlay2_Callback(hObject, eventdata, handles)
% hObject    handle to clrOlay2 (see GCBO)
  global ghandles
  global Exp
  set(ghandles.OLay2,'string',{''})
  set(ghandles.OLexp2,'string',{''})
  cla(ghandles.OLaxes2)
  Exp(2).traceN=0;
  %Exp(2).cTraceN=0;

  Exp(2).hOL =[]; Exp(2).hOLb=[];
  Exp(2).hOLname={}; Exp(2).hOLexpNm={}; Exp(2).hOLresDir={}
  Exp(2).hOLplateNum=[];
  Exp(2).hOLresDir={};

  cla(ghandles.Dlaxes2); cla(ghandles.Dkaxes2); cla(ghandles.Draxes2);
  cla(ghandles.DNLaxes2); % 2016_0222
  Exp(2).hL =[]; Exp(2).hLb=[];
  Exp(2).LRF1=[]; Exp(2).hLRF2=[];
  Exp(2).hK =[]; Exp(2).hKb=[];
  Exp(2).hKRF1=[]; Exp(2).hKRF2=[];
  Exp(2).hr =[]; Exp(2).hrb=[];
  Exp(2).rRF1=[]; Exp(2).hrRF2=[];

  %reset Composite Overlay plot to initialization values
  Exp(2).cTraceN=1;
  Exp(2).ll=[]; Exp(2).rr=[]; Exp(2).kk=[];
  Exp(2).cLmean=[]; Exp(2).cRmean=[]; Exp(2).cKmean=[];
  Exp(2).cTraceIndx=1;
  Exp(2).hCmean=[];
  Exp(2).hBound1=[];
  Exp(2).hBound2=[];
  Exp(2).CompositPlot=0;
  Exp(2).Trace=[];  %added for Trend BoxPlot data 17_1114
end


% Executes on slider movement
function MPsldr3_Callback(hObject, eventdata, handles)
% hObject    handle to MPsldr3 (see GCBO)
  global Exp
  expN=3;
  input=floor(get(hObject,'value'));
    display(input)
    set(handles.MPed3,'string',num2str(round(input)));
    EZVimDisplay
end

% Executes during object creation, after setting all properties.
%{
function MPsldr3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to MPsldr3 (see GCBO)
  if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
  end
end
%}


function MPed3_Callback(hObject, eventdata, handles)
% hObject    handle to MPed3 (see GCBO)
  global Exp
  global zonePB
  global ghandles

  expN=3;
  zonePB=expN;
  input=get(hObject,'String');
  Max=floor(get(handles.MPsldr3,'max'));
  Min=floor(get(handles.MPsldr3,'min'));
  if str2num(input) >=Min && str2num(input) <=Max
  display(input)
  set(handles.MPsldr3,'value',str2double(input));
  else
  if str2num(input) >=Max, set(handles.MPsldr3,'value',Max); set(handles.MPed3,'string',num2str(Max));end
  if str2num(input) <=Min, set(handles.MPsldr3,'value',Min),set(handles.MPed3,'string',num2str(Min));end
  end  
  EZVimDisplay
  ghandles.guiFig=gcf;
  Exp(4).guiFig=gcf;
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end

% Executes during object creation, after setting all properties.
%{
function MPed3_CreateFcn(hObject, eventdata, handles)
  global ghandles
  global Exp
  ghandles.guiFig=gcf;
  Exp(4).guiFig=gcf;
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end
%}

% --- Executes on slider movement.
function DMsldr3_Callback(hObject, eventdata, handles)
% hObject    handle to DMsldr3 (see GCBO)
  global Exp
  expN=3;
  input=floor(get(hObject,'value'));
    display(input)
    set(handles.DMed3,'string',num2str(round(input)))
    EZVimDisplay
end

% Executes during object creation, after setting all properties.
%{
function DMsldr3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DMsldr3 (see GCBO)
  global Exp
  if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
      set(hObject,'BackgroundColor',[.9 .9 .9]);
  end
end
%}


function DMed3_Callback(hObject, eventdata, handles)
% hObject    handle to DMed3 (see GCBO)
  global Exp
  expN=3;
  Max=floor(get(handles.DMsldr3,'max'));
  Min=floor(get(handles.DMsldr3,'min'));
  input=get(hObject,'String')
  if str2num(input) >=Min && str2num(input) <=Max
    display(input)
    set(handles.DMsldr3,'value',str2double(input))
  else
    if str2num(input) >=Max, set(handles.DMsldr3,'value',Max); set(handles.DMed3,'string',num2str(Max));end
    if str2num(input) <=Min, set(handles.DMsldr3,'value',Min),set(handles.DMed3,'string',num2str(Min));end
  end  
  EZVimDisplay
end

% Executes during object creation, after setting all properties.
function DMed3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DMed3 (see GCBO)
%       See ISPC and COMPUTER.
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end


% Executes on slider movement.
function Tptsldr3_Callback(hObject, eventdata, handles)
% hObject    handle to Tptsldr3 (see GCBO)
  global Exp
  expN=3;
  input=floor(get(hObject,'value'));
    display(input)
    set(handles.Tpted3,'string',num2str(floor(input)))
    prntHt=0;
    EZVimDisplay
end

% Executes during object creation, after setting all properties.
%{
function Tptsldr3_CreateFcn(hObject, eventdata, handles)
  % hObject    handle to Tptsldr3 (see GCBO)
  if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
      set(hObject,'BackgroundColor',[.9 .9 .9]);
  end
end
%}

function Tpted3_Callback(hObject, eventdata, handles)
% hObject    handle to Tpted3 (see GCBO)
  global Exp
  expN=3;
  input=get(hObject,'String')
  Max=floor(get(handles.Tptsldr3,'max'));
  Min=floor(get(handles.Tptsldr3,'min'));
  if str2double(input) >=Min && str2double(input) <=Max
    display(input)
    set(handles.Tptsldr3,'value',str2double(input))
  else
    if str2num(input) >=Max, set(handles.Tptsldr3,'value',Max); set(handles.Tpted3,'string',num2str(Max));end
    if str2num(input) <=Min, set(handles.Tptsldr3,'value',Min),set(handles.Tpted3,'string',num2str(Min));end
  end  
  EZVimDisplay
end

% Executes during object creation, after setting all properties.
function Tpted3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tpted3 (see GCBO)
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end

% Executes on button press in expSelPB3.
function expSelPB3_Callback(hObject, eventdata, handles)
% hObject    handle to expSelPB3 (see GCBO)
  global Exp
  expN=3;
  prntHt=0;
  EZexpSel
end

% Executes on button press in rotPB3.
function rotPB3_Callback(hObject, eventdata, handles)
% hObject    handle to rotPB3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  global ghandles
  ghandles=handles;
end

% Executes on button press in clrOlay3.
function clrOlay3_Callback(hObject, eventdata, handles)
% hObject    handle to clrOlay3 (see GCBO)
  global ghandles
  global Exp
  set(ghandles.OLay3,'string',{''})
  set(ghandles.OLexp3,'string',{''})
  cla(ghandles.OLaxes3);
  Exp(3).traceN=0; 
  %Exp(3).cTraceN=0;

  Exp(3).hOL =[]; Exp(3).hOLb=[];
  Exp(3).hOLname={}; Exp(3).hOLexpNm={}; Exp(3).hOLresDir={}
  Exp(3).hOLplateNum=[];
  Exp(3).hOLresDir={};

  cla(ghandles.Dlaxes3); cla(ghandles.Dkaxes3); cla(ghandles.Draxes3);
  cla(ghandles.DNLaxes3);% 2016_0222
  Exp(3).hL =[]; Exp(3).hLb=[];
  Exp(3).hLRF1=[]; Exp(3).hLRF2=[];
  Exp(3).hK =[]; Exp(3).hKb=[];
  Exp(3).hKRF1=[]; Exp(3).hKRF2=[];
  Exp(3).hr =[]; Exp(3).hrb=[];
  Exp(3).rRF1=[]; Exp(3).hrRF2=[];

  % Reset Composite Overlay plot to initialization values
  Exp(3).cTraceN=1;
  Exp(3).ll=[]; Exp(3).rr=[]; Exp(3).kk=[];
  Exp(3).cLmean=[]; Exp(3).cRmean=[]; Exp(3).cKmean=[];
  Exp(3).cTraceIndx=1;
  Exp(3).hCmean=[];
  Exp(3).hBound1=[];
  Exp(3).hBound2=[];
  Exp(3).CompositPlot=0;
  Exp(3).Trace=[];  % added for Trend BoxPlot data 17_1114
  % set(handles.expName3,'string',char(Exp(expN).resDir));
end

% Executes during object creation, after setting all properties.
function Paxes1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Paxes1 (see GCBO)
end

% Executes on selection change in listboxGnOrf.
function listboxGnOrf_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  global zonePB

  % orfLstSel=0;
  datacursormode off;
  zoneSel=1;
  %{
  if get(handles.zonePB1,'value')==1,
    zoneSel=1;
  elseif get(handles.zonePB2,'value')==1,
    zoneSel=2;
  elseif get(handles.zonePB3,'value')==1
    zoneSel=3;
  end
  %}
  zoneSel=zonePB
  orfLstSel=get(handles.GeneOrfTog,'value')
  % zoneSel=get(handles.zonePB1,'value')
  expN=zoneSel;
  OLay=zoneSel;

  usrInxSel=get(hObject,'Value');

  % selGnOrf=Exp(zoneSel).Dexp(DexpN).srtGnLst(usrInxSel);  %selGnOrf=Exp(zoneSel).srtGnLst(usrInxSel);
  listboxGnOrf=get(handles.listboxGnOrf,'string');
  selGnOrf=listboxGnOrf(usrInxSel);
  tempLB=str2mat(selGnOrf)
  if isequal(tempLB(4:6),'cmp')||isequal(tempLB(3:6),'cmpG')
    lstBoxCmpFlg=1;
    EZlstBoxCmpExt  %Added for RF composite behavior 17_1010
  else    
    LBdlims=strfind(selGnOrf,':')
    LBmp=str2num(selGnOrf{1}((LBdlims{:,:}(1))+1:(LBdlims{:,:}(2))-1))
    LBr=str2num(selGnOrf{1}((LBdlims{:,:}(2))+1:(LBdlims{:,:}(3))-1))
    LBc=str2num(selGnOrf{1}((LBdlims{:,:}(3))+1:end))
    lstBoxCmpFlg=0;
    EZlstBoxExt
  end

  datacursormode on;
end


% Executes during object creation, after setting all properties.
function listboxGnOrf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listboxGnOrf (see GCBO)
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end


% Executes on button press in GeneOrfTog.
function GeneOrfTog_Callback(hObject, eventdata, handles)
  global Exp
  orfLstSel=get(hObject,'value')
  %zoneSel=get(handles.zonePB1,'value')
  zoneSel=1;
  if get(handles.zonePB1,'value')==1,
    zoneSel=1;
  elseif get(handles.zonePB2,'value')==1,
    zoneSel=2;
  elseif get(handles.zonePB3,'value')==1
    zoneSel=3;
  end
  orfLstSel=get(handles.GeneOrfTog,'value');
  %zoneSel=get(handles.zonePB1,'value')
  expN=zoneSel;
  if zoneSel==1,DexpN=(get(handles.DN1,'value')); cmpTog=get(handles.CompositeTog1,'value'); end
  if zoneSel==2,DexpN=(get(handles.DN2,'value')); cmpTog=get(handles.CompositeTog2,'value'); end
  if zoneSel==3,DexpN=(get(handles.DN3,'value')); cmpTog=get(handles.CompositeTog3,'value'); end
  if orfLstSel==1 && cmpTog~=1
    set(handles.listboxGnOrf,'value',1)  
    set(handles.listboxGnOrf,'string',Exp(zoneSel).Dexp(DexpN).srtOrfLst)   %set(handles.listboxGnOrf,'string',Exp(zoneSel).srtOrfLst)   
  else
    set(handles.listboxGnOrf,'value',1)
    set(handles.listboxGnOrf,'string',Exp(zoneSel).Dexp(DexpN).srtGnLst)  %set(handles.listboxGnOrf,'string',Exp(zoneSel).srtGnLst)
  end
end


% Executes on button press in InfoToggle.
function InfoToggle_Callback(hObject, eventdata, handles)
% --- Executes on button press in zonePB1.
end


% Executes on button press in semiLog.
function semiLog_Callback(hObject, eventdata, handles)
  global Exp
  semiLog=get(handles.semiLog,'value')
  if semiLog==1
    set(handles.semiLog,'BackgroundColor',[1.0 0.6 0.6])   
    set(handles.semiLog,'ForegroundColor',[1.0 0.0, 0.0])
    set(handles.Paxes1,'YScale','log')
    set(handles.Paxes2,'YScale','log')
    set(handles.Paxes3,'YScale','log')
    set(handles.OLaxes1,'YScale','log')
    set(handles.OLaxes2,'YScale','log')
    set(handles.OLaxes3,'YScale','log')
  else
    set(handles.semiLog,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.semiLog,'ForegroundColor',[0.0 0.0, 0.0])
    set(handles.Paxes1,'YScale','linear')
    set(handles.Paxes2,'YScale','linear')
    set(handles.Paxes3,'YScale','linear')
    set(handles.OLaxes1,'YScale','linear')
    set(handles.OLaxes2,'YScale','linear')
    set(handles.OLaxes3,'YScale','linear')
  end
end


% Executes on button press in spotTog.
function spotTog_Callback(hObject, eventdata, handles)
% Hint: get(hObject,'Value') returns toggle state of spotTog
  global Exp
  global ghandles

  spotTog=get(handles.spotTog,'value');
  ghandles=handles
  if spotTog==1
    set(handles.spotTog,'BackgroundColor',[0.0 0.75 0.75])   
    set(handles.spotTog,'ForegroundColor',[0.0 0.0, 0.0])
  else
    set(handles.spotTog,'BackgroundColor',[.941 0.941, 0.941])
    set(handles.spotTog,'ForegroundColor',[0.0 0.0, 0.0]) 
  end
end


function quickView_Callback(hObject, eventdata, handles) %function quickView_Callback(hObject, eventdata, handles)
% hObject    handle to quickView (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  global Exp
  try   
    QkVexps % Quickview
  catch
  end
end


% Executes on button press in printOL1.
function printOL1_Callback(hObject, eventdata, handles)
% hObject    handle to printOL1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% If Enable =='on', executes on mouse press in 5 pixel border.
% Otherwise, executes on mouse press in 5 pixel border or over printol1.
  global Exp
  global ghandles
  ads1=0
  EZvFigPrint
  set(handles.printOL1,'value',0)
end

%{
function printOL1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to printol1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  ads1=1
end

% Executes on key press with focus on printOL1 and none of its controls.
function printOL1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to printOL1 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
  ads1=2
end
%}


% Executes on button press in printOL2.
function printOL2_Callback(hObject, eventdata, handles)
% hObject    handle to printOL2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  global Exp
  global ghandles
  ads1=0
  EZvFigPrint
  set(handles.printOL2,'value',0)
end

% Executes on key press with focus on printOL2 and none of its controls.
%{
 function printOL2_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to printOL2 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

% --- If Enable =='on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over printOL2.
  ads2=1
end

function printOL2_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to printOL2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  ads2=2
end
%}



% Executes on button press in printOL3.
function printOL3_Callback(hObject, eventdata, handles)
% hObject    handle to printOL3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  global Exp
  global ghandles
  ads1=0
  EZvFigPrint
  set(handles.printOL3,'value',0)
end

% Executes on key press with focus on printOL3 and none of its controls.
%{
 function printOL3_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to printOL3 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

% --- If Enable =='on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over printOL3.
  ads3=1
end

function printOL3_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to printOL3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
  ads3=2
end
 %}   
    
function figure1_WindowButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  htargetAxes=gca;
  cpos=get(gca,'Position')
  if handles.Iaxes1==gca||...
    handles.Iaxes2==gca||...
    handles.Iaxes3==gca||... 
    handles.OLaxes1==gca||...
    handles.OLaxes2==gca||...
    handles.OLaxes3==gca,
    EZvDatatip
  end
end

% Executes on mouse press over figure background, over a disabled or
% inactive control, or over an axes background.
function figure1_WindowButtonUpFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
end


function Tools_Callback(hObject, eventdata, handles)
% hObject    handle to Tools (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
end


function Parameters_Callback(hObject, eventdata, handles)
% hObject    handle to Parameters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
end


function PrintFont_Callback(hObject, eventdata, handles)
% hObject    handle to PrintFont (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  global Exp
  global ghandles

  prompt={...
    'Enter Linewidth for plot:',...
    'Enter Axis Font Size:',...
    'Enter Legend Font Size:',...
    'Enter Marker Font Size:'};
      
  name='Input Size Parameters for Printable Graphic';
  numlines=1;

  try
    if ~isempty(Exp(4).plotPars)
      default=Exp(4).plotPars;
    else
      default={'4','36','10','5'};
    end
  catch
    default={'4','36','10','5'};
  end

  answer=inputdlg(prompt,name,numlines,default)

  if ~isempty(answer)
    Exp(4).plotPars=answer;
  %{
  else
      default={'4','36','10','5'};
      Exp(4).plotPars=default;
  %}
  end
end

% Executes on button press in LKrTog1.
function LKrTog1_Callback(hObject, eventdata, handles)
  global Exp
  expN=1;
  EZfigTrendOL
end

% Executes on button press in LKrTog2.
function LKrTog2_Callback(hObject, eventdata, handles)
  global Exp
  expN=2;
  EZfigTrendOL
end

% Executes on button press in LKrTog3.
function LKrTog3_Callback(hObject, eventdata, handles)
  global Exp
  expN=3;
  EZfigTrendOL
end

% Executes on button press in rawNorm.
function rawNorm_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles

  traceN1=Exp(1).traceN;
  traceN2=Exp(2).traceN;
  traceN3=Exp(3).traceN;
  selTrace1=Exp(1).seltraceN;
  selTrace2=Exp(2).seltraceN;
  selTrace3=Exp(3).seltraceN;
  
  dispAlg=get(handles.rawNorm,'value')
  
  Exp(4).interacPBsel=Exp(4).interacPBsel+1;
  if Exp(4).interacPBsel ==2, Exp(4).interacPBsel=0; end 
  %set(handles.rawNorm,'value',Exp(4).interacPBsel)
  
  if Exp(4).interacPBsel ==1
    set(handles.rawNorm,'string','N1');
  elseif Exp(4).interacPBsel ==2
    set(handles.rawNorm,'string','N2');
  else 
    set(handles.rawNorm,'string','R');
  end
  
  if Exp(4).interacPBsel==0
    set(ghandles.Dlaxes1,'Visible','on');set(ghandles.Dlaxes2,'Visible','on'); set(ghandles.Dlaxes3,'Visible','on')
    set(ghandles.DNLaxes1,'Visible','off'); set(ghandles.DNLaxes2,'Visible','off'); set(ghandles.DNLaxes3,'Visible','off')
    
    for i=1:3
      Exp(i).expLoadCnt
      try 
        set(Exp(i).hzeroCLn(1),'visible','off'); 
      catch ME
        ME.message
      end
    end

    %{
    try set(Exp(1).hzeroCLn,'visible','off');
    catch ME, ME.message, 
      try plot(handles.DNLaxes1,zeros(1,Exp(1).destPerMP),1:Exp(1).destPerMP,'w'); catch  end
    end %
    try set(Exp(2).hzeroCLn,'visible','off'); 
    catch ME, ME.message,
      try plot(handles.DNLaxes2,zeros(1,Exp(2).destPerMP),1:Exp(2).destPerMP,'w'); catch  end 
    end %  
    try set(Exp(3).hzeroCLn,'visible','off');
    catch ME, ME.message,
        try plot(handles.DNLaxes3,zeros(1,Exp(3).destPerMP),1:Exp(3).destPerMP,'w'); catch end 
    end % 
    %}

    for n=1:traceN1
      try 
        set(Exp(1).hintL(n),'visible','off');
        set(Exp(1).hintLb(n),'visible','off')
      catch
      end
      try 
        set(Exp(1).hintLadj(n),'visible','off');
        set(Exp(1).hintLadjb(n),'visible','off');
      catch
      end  
      try set(Exp(1).hLRF1(n),'visible','off')
        set(Exp(1).hLRF2(n),'visible','off')
      catch
      end
      try set(Exp(1).hL(n),'visible','off');
        set(Exp(1).hLb(n),'visible','off');
      catch
      end  
    end

    try set(Exp(1).hLRF1(selTrace1),'visible','on');
      set(Exp(1).hLRF2(selTrace1),'visible','on')
    catch
    end
    try set(Exp(1).hL(selTrace1),'visible','on')
      set(Exp(1).hLb(selTrace1),'visible','on')
    catch
    end

    for n=1:traceN2
      try
        set(Exp(2).hintL(n),'visible','off');
        set(Exp(2).hintLb(n),'visible','off');
      catch
      end
      try 
        set(Exp(2).hintLadj(n),'visible','off');
        set(Exp(2).hintLadjb(n),'visible','off');
      catch
      end  
      try 
        set(Exp(2).hLRF1(n),'visible','off');
        set(Exp(2).hLRF2(n),'visible','off');
      catch
      end
      try 
        set(Exp(2).hL(n),'visible','off');
        set(Exp(2).hLb(n),'visible','off');
      catch
      end  
    end

    try
      set(Exp(2).hLRF1(selTrace2),'visible','on');
      set(Exp(2).hLRF2(selTrace2),'visible','on');
    catch
    end
    try set(Exp(2).hL(selTrace2),'visible','on');
      set(Exp(2).hLb(selTrace2),'visible','on');
    catch
    end  
    
    for n=1:traceN3
      try 
        set(Exp(3).hintL(n),'visible','off');
        set(Exp(3).hintLb(n),'visible','off');
      catch
      end
      try 
        set(Exp(3).hintLadj(n),'visible','off');
        set(Exp(3).hintLadjb(n),'visible','off');
      catch
      end  
      try 
        set(Exp(3).hLRF1(n),'visible','off');
        set(Exp(3).hLRF2(n),'visible','off'); 
      catch
      end
      try 
        set(Exp(3).hL(n),'visible','off');
        set(Exp(3).hLb(n),'visible','off');
      catch
      end  
    end

    try
      set(Exp(3).hLRF1(selTrace3),'visible','on');
      set(Exp(3).hLRF2(selTrace3),'visible','on');
    catch
    end
    try
      set(Exp(3).hL(selTrace3),'visible','on');
      set(Exp(3).hLb(selTrace3),'visible','on');
    catch
    end  
  elseif Exp(4).interacPBsel==1
    set(ghandles.Dlaxes1,'Visible','off'); set(ghandles.Dlaxes2,'Visible','off'); set(ghandles.Dlaxes3,'Visible','off');
    set(ghandles.DNLaxes1,'Visible','on'); set(ghandles.DNLaxes2,'Visible','on'); set(ghandles.DNLaxes3,'Visible','on');
    %{ 
    try plot(handles.DNLaxes1,zeros(1,Exp(1).destPerMP),1:Exp(1).destPerMP,'y'); catch ME, ME.message, end %set(Exp(1).hzeroCLn,'visible','off');
    try plot(handles.DNLaxes2,zeros(1,Exp(2).destPerMP),1:Exp(2).destPerMP,'y'); catch ME, ME.message, end %set(Exp(2).hzeroCLn,'visible','off');  
    try plot(handles.DNLaxes3,zeros(1,Exp(3).destPerMP),1:Exp(3).destPerMP,'y'); catch ME, ME.message, end %set(Exp(3).hzeroCLn,'visible','off'); 
    %}
    for i=1:Exp(1).expLoadCnt,try set(Exp(1).hzeroCLn(i),'visible','on'); catch ME, ME.message, end, end
    for i=1:Exp(2).expLoadCnt,try set(Exp(2).hzeroCLn(i),'visible','on'); catch ME, ME.message, end, end
    for i=1:Exp(3).expLoadCnt,try set(Exp(3).hzeroCLn(i),'visible','on'); catch ME, ME.message, end, end
      
    for n=1:traceN1
      try set(Exp(1).hLRF1(n),'visible','off');  set(Exp(1).hLRF2(n),'visible','off'); catch, end
      try set(Exp(1).hL(n),'visible','off');  set(Exp(1).hLb(n),'visible','off'); catch, end 
      try set(Exp(1).hintL(n),'visible','off');  set(Exp(1).hintLb(n),'visible','off'); catch, end
      try set(Exp(1).hintLadj(n),'visible','off');  set(Exp(1).hintLadjb(n),'visible','off'); catch, end  
    end
    try set(Exp(1).hintL(selTrace1),'visible','on');  set(Exp(1).hintLb(selTrace1),'visible','on'); catch, end
    try set(Exp(1).hintLadj(selTrace1),'visible','on');  set(Exp(1).hintLadjb(selTrace1),'visible','on'); catch, end  
    for n=1:traceN2
      try set(Exp(2).hLRF1(n),'visible','off');  set(Exp(2).hLRF2(n),'visible','off'); catch, end
      try set(Exp(2).hL(n),'visible','off');  set(Exp(2).hLb(n),'visible','off'); catch, end 
      try set(Exp(2).hintL(n),'visible','off');  set(Exp(2).hintLb(n),'visible','off'); catch, end
      try set(Exp(2).hintLadj(n),'visible','off');  set(Exp(2).hintLadjb(n),'visible','off'); catch, end  
    end
    try set(Exp(2).hintL(selTrace2),'visible','on');  set(Exp(2).hintLb(selTrace2),'visible','on'); catch, end
    try set(Exp(2).hintLadj(selTrace2),'visible','on');  set(Exp(2).hintLadjb(selTrace2),'visible','on'); catch, end     
    for n=1:traceN3
      try set(Exp(3).hLRF1(n),'visible','off');  set(Exp(3).hLRF2(n),'visible','off'); catch, end
      try set(Exp(3).hL(n),'visible','off');  set(Exp(3).hLb(n),'visible','off'); catch, end 
      try set(Exp(3).hintL(n),'visible','off');  set(Exp(3).hintLb(n),'visible','off'); catch, end
      try set(Exp(3).hintLadj(n),'visible','off');  set(Exp(3).hintLadjb(n),'visible','off'); catch, end  
    end
    try set(Exp(3).hintL(selTrace3),'visible','on');  set(Exp(3).hintLb(selTrace3),'visible','on'); catch, end
    try set(Exp(3).hintLadj(selTrace3),'visible','on');  set(Exp(3).hintLadjb(selTrace3),'visible','on'); catch, end  
  elseif Exp(4).interacPBsel==2
    % set(ghandles.DNLaxes1,'Visible','off')
  end
end
    
% hObject    handle to rawNorm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of rawNorm

% Executes on button press in InteracTog1.
function InteracTog1_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  expN=1;
  if strcmp(Exp(expN).DexpType,'single')|| strcmp(Exp(expN).DexpType,'multi') 
    EZinteractDev4
  elseif strcmp(Exp(expN).DexpType,'chrono')
    EZinteractDev5
  end
end

% Hint: get(hObject,'Value') returns toggle state of InteracTog1
% Executes on button press in InteracTog2.
function InteracTog2_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  expN=2;
  if strcmp(Exp(expN).DexpType,'single')|| strcmp(Exp(expN).DexpType,'multi') 
    EZinteractDev4
  elseif strcmp(Exp(expN).DexpType,'chrono')
    EZinteractDev5
  end
end

% Hint: get(hObject,'Value') returns toggle state of InteracTog2
% Executes on button press in InteracTog3.
function InteracTog3_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  expN=3;
  if strcmp(Exp(expN).DexpType,'single')|| strcmp(Exp(expN).DexpType,'multi') 
    EZinteractDev4
  elseif strcmp(Exp(expN).DexpType,'chrono')
    EZinteractDev5
  end
end


% Executes on key press with focus on rawNorm and none of its controls.
function rawNorm_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to rawNorm (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
end

% --- Executes on button press in HtMapTog1.
function HtMapTog1_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles

  prntHt=0;
  DexpN=Exp(1).DexpN;
  resetTg=Exp(1).Dexp(DexpN).resetHtmpTg;
  expN=1;
  Exp(1).htmapPBsel=Exp(1).htmapPBsel+1;
  if Exp(1).htmapPBsel==resetTg, Exp(1).htmapPBsel=0; end 
  if Exp(1).htmapPBsel==3, set(handles.HtMapTog1,'string','N1')
  elseif Exp(1).htmapPBsel==4, set(handles.HtMapTog1,'string','N2')
  elseif Exp(1).htmapPBsel==1, set(handles.HtMapTog1,'string','K')
  elseif Exp(1).htmapPBsel==2, set(handles.HtMapTog1,'string','R')    
  else set(handles.HtMapTog1,'string','L'),
  end

  htMapTogPBfg=1;
  EZhtMap
  htMapTogPBfg=0;
end
    
% Executes on button press in HtMapTog2.
function HtMapTog2_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles

  prntHt=0;
  expN=2;
  DexpN=Exp(2).DexpN;
  resetTg=Exp(2).Dexp(DexpN).resetHtmpTg;
  Exp(2).htmapPBsel=Exp(2).htmapPBsel+1;
  if Exp(2).htmapPBsel==resetTg, Exp(2).htmapPBsel=0; end
  if Exp(2).htmapPBsel==3, set(handles.HtMapTog2,'string','N1')
  elseif Exp(2).htmapPBsel==4, set(handles.HtMapTog2,'string','N2')
  elseif Exp(2).htmapPBsel==1, set(handles.HtMapTog2,'string','K') 
  elseif Exp(2).htmapPBsel==2, set(handles.HtMapTog2,'string','R')    
  else set(handles.HtMapTog2,'string','L'),
  end

  htMapTogPBfg=1;
  EZhtMap
  htMapTogPBfg=0;
end
   
%Executes on button press in HtMapTog3.
function HtMapTog3_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles

  prntHt=0;
  expN=3;
  DexpN=Exp(3).DexpN;
  resetTg=Exp(3).Dexp(DexpN).resetHtmpTg;
  Exp(3).htmapPBsel=Exp(3).htmapPBsel+1;
  if Exp(3).htmapPBsel==resetTg, Exp(3).htmapPBsel=0; end 
  if Exp(3).htmapPBsel==3, set(handles.HtMapTog3,'string','N1')
  elseif Exp(3).htmapPBsel==4, set(handles.HtMapTog3,'string','N2')
  elseif Exp(3).htmapPBsel==1, set(handles.HtMapTog3,'string','K') 
  elseif Exp(3).htmapPBsel==2, set(handles.HtMapTog3,'string','R')    
  else set(handles.HtMapTog3,'string','L'),
  end

  htMapTogPBfg=1;
  EZhtMap
  htMapTogPBfg=0;
end


% Deprecated functions
%{ 
%--- Executes on button press in semiLog.
function semiLog_Callback(hObject, eventdata, handles)
% hObject    handle to semiLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of semiLog
%}

% --- Executes on key press with focus on listboxGnOrf and none of its controls.
%{
function listboxGnOrf_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to listboxGnOrf (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
x=eventdata
ck=get(gcf,'currentkey')
%}

%{
% Clear Trace selections for all zones
global Exp
global ghandles

set(ghandles.OLay1,'string',{' '})
set(ghandles.OLexp1,'string',{''})
cla(ghandles.OLaxes1)
Exp(1).traceN=0;
Exp(1).hOL =[]; Exp(1).hOLb=[];
Exp(1).hOLname={}; Exp(1).hOLexpNm={}; Exp(1).hOLresDir={}
Exp(1).hOLplateNum=[];
Exp(1).hOLresDir={};

set(ghandles.OLay2,'string',{''})
set(ghandles.OLexp2,'string',{''})
cla(ghandles.OLaxes2)
Exp(2).traceN=0;
Exp(2).hOL =[]; Exp(2).hOLb=[];
Exp(2).hOLname={}; Exp(2).hOLexpNm={}; Exp(2).hOLresDir={}
Exp(2).hOLplateNum=[];
Exp(2).hOLresDir={};

set(ghandles.OLay3,'string',{''})
set(ghandles.OLexp3,'string',{''})
cla(ghandles.OLaxes3);
Exp(3).traceN=0; 
Exp(3).hOL =[]; Exp(3).hOLb=[];
Exp(3).hOLname={}; Exp(3).hOLexpNm={}; Exp(3).hOLresDir={}
Exp(3).hOLplateNum=[];
Exp(3).hOLresDir={};
%}

% hObject    handle to quickView (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Executes on button press in RFtable1.
function RFtable1_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  expN=1;
  DexpN=get(handles.DN1,'value');
  EZtableRFdiag
end

% Executes on button press in RFtable2.
function RFtable2_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  expN=2;
  DexpN=get(handles.DN2,'value');
  EZtableRFdiag
end

% Executes on button press in RFtable3.
function RFtable3_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  expN=3;
  DexpN=get(handles.DN3,'value');
  EZtableRFdiag
end


function DN1_Callback(hObject, eventdata, handles)
% hObject    handle to DN1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% str2double(get(hObject,'String')) returns contents of DN1 as a double
  global Exp
  expN=1;
  input=get(hObject,'String');
  Max=Exp(expN).DexpLength;
  Min=0; %(get(handles.DN1,'min'));
  if str2num(input) > Min && str2num(input) <=Max
    display(input)
    set(handles.DN1,'value',str2double(input));
  else
    if str2double(input) >=Max, set(handles.DN1,'value',Max); set(handles.DN1,'string',num2str(Max));end
    if str2double(input) <=Min, set(handles.DN1,'value',Min),set(handles.DN1,'string',num2str(1));end
  end  
  EZVimDisplay
end


% Executes during object creation, after setting all properties.
function DN1_CreateFcn(hObject, eventdata, handles)
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end

function DN2_Callback(hObject, eventdata, handles)
  global Exp
  expN=2;
  input=get(hObject,'String');
  Max=Exp(expN).DexpLength;
  Min=0; %(get(handles.DN1,'min'));
  if str2num(input) > Min && str2num(input) <=Max
    display(input)
    set(handles.DN2,'value',str2double(input));
  else
    if str2double(input) >=Max, set(handles.DN2,'value',Max); set(handles.DN2,'string',num2str(Max));end
    if str2double(input) <=Min, set(handles.DN2,'value',Min),set(handles.DN2,'string',num2str(1));end
  end  
  EZVimDisplay
end

% Executes during object creation, after setting all properties.
function DN2_CreateFcn(hObject, eventdata, handles)
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end

function DN3_Callback(hObject, eventdata, handles)
  global Exp
  expN=3;
  input=get(hObject,'String');
  Max=Exp(expN).DexpLength;
  Min=0; % (get(handles.DN1,'min'));
  if str2num(input) > Min && str2num(input) <=Max
    display(input)
    set(handles.DN3,'value',str2double(input));
  else
    if str2double(input) >=Max, set(handles.DN3,'value',Max); set(handles.DN3,'string',num2str(Max));end
    if str2double(input) <=Min, set(handles.DN3,'value',Min),set(handles.DN3,'string',num2str(1));end
  end  
  EZVimDisplay
end

% Executes during object creation, after setting all properties.
function DN3_CreateFcn(hObject, eventdata, handles)
  if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
  end
end

% Executes on button press in CompositePB1.
function CompositePB1_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
    expN=1;
    DexpN=get(handles.DN1,'value');
    EZcompositePlot
end

% Executes on button press in CompositePB2.
function CompositePB2_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  expN=2;
  DexpN=get(handles.DN2,'value');
  EZcompositePlot
end

% Executes on button press in CompositePB3.
function CompositePB3_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  expN=3;
  DexpN=get(handles.DN3,'value');
  EZcompositePlot
end

function SpotViewInterval_Callback(hObject, eventdata, handles)
% hObject    handle to SpotViewInterval (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

  global Exp
  global ghandles

  prompt={'Enter Image Interval for SpotView:'};
  name='Input Image Interval for SpotView';
  numlines=1

  try
    if ~isempty(Exp(4).SpotVIntervPar)
      default=Exp(4).SpotVIntervPar;
    else
      default={'1'};
    end
  catch
    default={'1'};
  end

  answer=inputdlg(prompt,name,numlines,default)
  if ~isempty(answer)
    Exp(4).SpotVintervPar=answer;
  end
end


% Executes on button press in CompositeTog1.
function CompositeTog1_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  ghandles=handles;

  expN=1; 
  DexpN=(get(handles.DN1,'value'));
  %set(handles.zonePB1,'value',1)
  %set(handles.zonePB2,'value',0)
  %set(handles.zonePB3,'value',0)
  if get(handles.zonePB1,'value')==1 && get(handles.CompositeTog1,'value')==1
  set(handles.GeneOrfTog,'value',0) 
  set(handles.listboxGnOrf,'value',1)
  set(handles.listboxGnOrf,'string',Exp(expN).Dexp(DexpN).srtGnLst)
  set(handles.CompositeTog1,'BackgroundColor',[1.0 0.6 0.6])   
  set(handles.CompositeTog1,'ForegroundColor',[1.0 0.0, 0.0])
  else
    set(handles.CompositeTog1,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.CompositeTog1,'ForegroundColor',[0.0 0.0, 0.0])   
  end
end


% Executes on button press in CompositeTog2.
function CompositeTog2_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  ghandles=handles;

  expN=2; 
  DexpN=(get(handles.DN2,'value'));
  %set(handles.zonePB1,'value',0)
  %set(handles.zonePB2,'value',1)
  %set(handles.zonePB3,'value',0)

  if get(handles.zonePB2,'value')==1 && get(handles.CompositeTog2,'value')==1
    set(handles.GeneOrfTog,'value',0)    
    set(handles.listboxGnOrf,'value',1)  
    set(handles.listboxGnOrf,'string',Exp(expN).Dexp(DexpN).srtGnLst)
    set(handles.CompositeTog2,'BackgroundColor',[1.0 0.6 0.6])   
    set(handles.CompositeTog2,'ForegroundColor',[1.0 0.0, 0.0])
  else
    set(handles.CompositeTog2,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.CompositeTog2,'ForegroundColor',[0.0 0.0, 0.0])   
  end
end

% Executes on button press in CompositeTog3.
function CompositeTog3_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  ghandles=handles;

  expN=3; 
  DexpN=(get(handles.DN3,'value'));
  %set(handles.zonePB1,'value',0)
  %set(handles.zonePB2,'value',0)
  %set(handles.zonePB3,'value',1)
  if get(handles.zonePB3,'value')==1 && get(handles.CompositeTog3,'value')==1
    set(handles.GeneOrfTog,'value',0)   
    set(handles.listboxGnOrf,'value',1)  
    set(handles.listboxGnOrf,'string',Exp(expN).Dexp(DexpN).srtGnLst)
    set(handles.CompositeTog3,'BackgroundColor',[1.0 0.6 0.6])   
    set(handles.CompositeTog3,'ForegroundColor',[1.0 0.0, 0.0])
  else
    set(handles.CompositeTog3,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.CompositeTog3,'ForegroundColor',[0.0 0.0, 0.0])  
  end
end


function TrendsBoxPlot_Callback(hObject, eventdata, handles)
  global userPars
  userPars.boxplotFlg=1;
  prompt={...
    'Set "Outliers" On/Off:', ...
    'Set "Notch"  On/Off:', ...
    'Enter "LabelShift" value[default=0.5]:', ...
    'Enter "Font Size [default=8:' ...
    'Enter "Label Angle" [default=45]' ...
    'Enter Upper K Limit value[typical=155]:'}; 
  name='Box Plot Parameters';
  numlines=1;
  %defaultanswer={'on','on','0.3','8','45'};
  defaultanswer=userPars.BPdefault;
  answer=inputdlg(prompt,name,numlines,defaultanswer);
  userPars.BPoutliers=answer(1);
  userPars.BPnotch=answer(2);
  userPars.BPlblShft=str2double(cell2mat(answer(3)));
  userPars.BPfontSz=str2double(cell2mat(answer(4)));
  userPars.BProt=str2double(cell2mat(answer(5)));
  userPars.kfiltLim=str2double(cell2mat(answer(6)));
  userPars.BPdefault=[answer(1),answer(2),answer(3),answer(4),answer(5),answer(6)];
  userPars.Trenddefault=answer(6);
end


function TrendsOverlay_Callback(hObject, eventdata, handles)
  global userPars

  userPars.boxplotFlg=0;
  prompt={'Enter Upper K Limit value[typical=155]:'}; 
  name='Box Plot Parameters';
  numlines=1;
  % defaultanswer={'1000'};
  % if ~exist('userPars.Trenddefault','var'), userPars.Trenddefault={'1000'}; end
  defaultanswer=userPars.BPdefault(6)
  % try
  %   defaultanswer=userPars.Trenddefault;
  % catch
  %   userPars.Trenddefault={'1000'}
  %   defaultanswer=userPars.Trenddefault;
  % end
  answer=inputdlg(prompt,name,numlines,defaultanswer);
  userPars.kfiltLim=str2double(cell2mat(answer(1)));
  %userPars.Trenddefault=answer(1);
  userPars.BPdefault(6)=answer(1);
end

% Executes on button press in printHt1.
function printHt1_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  DexpN=Exp(1).DexpN;
  expN=1;
  prntHt=1;
  htMapTogPBfg=1;
  EZhtMap
  prntHt=0;
end

% Executes on button press in PrintHt2.
function PrintHt2_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  DexpN=Exp(2).DexpN;
  expN=2;
  prntHt=2;
  htMapTogPBfg=2;
  EZhtMap
  prntHt=0;
end

% Executes on button press in PrintHt3.
function PrintHt3_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  DexpN=Exp(1).DexpN;
  expN=3;
  prntHt=3;
  htMapTogPBfg=3;
  EZhtMap
  prntHt=0;
end


function HMapRange_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  global adj
  global flip

  prompt={'Enter Standard Deviation Multiplier value[typical=2.0]:'};    
  % prompt={'Enter Standard Deviation Multiplier value[typical=3.0]:','Colormap Flip[Typical=T]'};    
  name='Heatmap Adjustment range';
  numlines=1;
  defaultanswer={'2.0'};
  % defaultanswer={'3.0','T'};
  answer=inputdlg(prompt,name,numlines,defaultanswer);
  adj=str2double(answer(1));
  flip='T';
  % flip=upper(answer(2));
end

function setScansDir_Callback(hObject, eventdata, handles)
% hObject    handle to SetExpJobsFolder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA
  % if ~exist('scansDir','var')
  scansDir=uigetdir('default','Set Project Scans Folder')
  % end
end

% Executes on button press in zonePB1.
function zonePB1_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  global zonePB

  % if get(handles.zonePB1,'value')==0, set(handles.zonePB1,'value',1); end
  zonePB=1
  set(handles.zonePB1,'value',1);
  DexpN=get(handles.DN1,'value')
  set(handles.zonePB2,'value',0)
  set(handles.zonePB3,'value',0)
  orfLstSel=get(handles.GeneOrfTog,'value')

  if get(handles.GeneOrfTog,'value')==1
    set(handles.listboxGnOrf,'string',Exp(1).Dexp(DexpN).srtOrfLst) % set(handles.listboxGnOrf,'string',Exp(1).srtOrfLst)   
  else
    set(handles.listboxGnOrf,'string',Exp(1).Dexp(DexpN).srtGnLst) % set(handles.listboxGnOrf,'string',Exp(1).srtGnLst)
  end

  % switch background color to indicate zone selected 230815
  if get(handles.zonePB1,'value')==1
    set(handles.zonePB1,'BackgroundColor',[1.0 0.6 0.6])
    set(handles.zonePB2,'BackgroundColor',[1.0 1.0 1.0])
    set(handles.zonePB3,'BackgroundColor',[1.0 1.0 1.0]) 
  end

  if get(handles.zonePB1,'value')==1 && get(handles.CompositeTog1,'value')==1
    set(handles.GeneOrfTog,'value',0); 
    set(handles.listboxGnOrf,'value',1);
    set(handles.listboxGnOrf,'string',Exp(1).Dexp(DexpN).srtGnLst)
    set(handles.CompositeTog1,'BackgroundColor',[1.0 0.6 0.6]);   
    set(handles.CompositeTog1,'ForegroundColor',[1.0 0.0, 0.0]);
    set(handles.zonePB1,'BackgroundColor',[1.0 0.6 0.6]); 
  end
end


% Executes on button press in zonePB2
function zonePB2_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  global zonePB

  zonePB=2
  %if get(handles.zonePB2,'value')==0, set(handles.zonePB2,'value',1); end
  set(handles.zonePB2,'value',1);
  DexpN=get(handles.DN2,'value')
  set(handles.zonePB1,'value',0);
  set(handles.zonePB3,'value',0);
  set(ghandles.zonePB2,'value',1);
  set(ghandles.zonePB1,'value',0);
  set(ghandles.zonePB3,'value',0);
  orfLstSel=get(handles.GeneOrfTog,'value')
  if orfLstSel==1
    set(handles.listboxGnOrf,'string',Exp(2).Dexp(DexpN).srtOrfLst)   %set(handles.listboxGnOrf,'string',Exp(2).srtOrfLst)   
  else
    set(handles.listboxGnOrf,'string',Exp(2).Dexp(DexpN).srtGnLst)  %set(handles.listboxGnOrf,'string',Exp(2).srtGnLst)
  end
  % switch background color to indicate zone selected 230815
  if get(handles.zonePB2,'value')==1
    set(handles.zonePB2,'BackgroundColor',[1.0 0.6 0.6])
    set(handles.zonePB1,'BackgroundColor',[1.0 1.0 1.0])
    set(handles.zonePB3,'BackgroundColor',[1.0 1.0 1.0])
    set(ghandles.zonePB2,'value',1);
    set(ghandles.zonePB1,'value',0);
    set(ghandles.zonePB3,'value',0);
  end
  if get(handles.zonePB2,'value')==1 && get(handles.CompositeTog2,'value')==1
    set(handles.GeneOrfTog,'value',0)    
    set(handles.listboxGnOrf,'value',1)  
    set(handles.listboxGnOrf,'string',Exp(2).Dexp(DexpN).srtGnLst)
    set(handles.CompositeTog2,'BackgroundColor',[1.0 0.6 0.6])   
    set(handles.CompositeTog2,'ForegroundColor',[1.0 0.0, 0.0])
    set(handles.zonePB2,'BackgroundColor',[1.0 0.6 0.6])
  else
    set(handles.CompositeTog2,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.CompositeTog2,'ForegroundColor',[0.0 0.0, 0.0])   
  end
end


% Executes on button press in zonePB3.
function zonePB3_Callback(hObject, eventdata, handles)
  global Exp
  global ghandles
  global zonePB

  zonePB=3
  %if get(handles.zonePB3,'value')==0, set(handles.zonePB3,'value',1); end
  set(handles.zonePB3,'value',1);
  DexpN=get(handles.DN3,'value');
  set(handles.zonePB1,'value',0);
  set(handles.zonePB2,'value',0);
  set(ghandles.zonePB3,'value',1);
  set(ghandles.zonePB1,'value',0);
  set(ghandles.zonePB2,'value',0);

  orfLstSel=get(handles.GeneOrfTog,'value');
  if orfLstSel==1
    set(handles.listboxGnOrf,'string',Exp(3).Dexp(DexpN).srtOrfLst);   %set(handles.listboxGnOrf,'string',Exp(3).srtOrfLst)   
  else
    set(handles.listboxGnOrf,'string',Exp(3).Dexp(DexpN).srtGnLst);  %set(handles.listboxGnOrf,'string',Exp(3).srtGnLst)
  end

  % switch background color to indicate zone selected 230815
  if get(handles.zonePB3,'value')==1
    set(handles.zonePB3,'BackgroundColor',[1.0 0.6 0.6]);
    set(handles.zonePB1,'BackgroundColor',[1.0 1.0 1.0]);
    set(handles.zonePB2,'BackgroundColor',[1.0 1.0 1.0]);
  end

  if get(handles.zonePB3,'value')==1 && get(handles.CompositeTog3,'value')==1
    set(handles.GeneOrfTog,'value',0)
    set(handles.listboxGnOrf,'value',1)  
    set(handles.listboxGnOrf,'string',Exp(3).Dexp(DexpN).srtGnLst)
    set(handles.CompositeTog3,'BackgroundColor',[1.0 0.6 0.6])   
    set(handles.CompositeTog3,'ForegroundColor',[1.0 0.0, 0.0])
    set(handles.zonePB3,'BackgroundColor',[1.0 0.6 0.6])
  else
    set(handles.CompositeTog3,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.CompositeTog3,'ForegroundColor',[0.0 0.0, 0.0])  
  end
end


% Deprecated functions
%{
% RadioButton1*************************
function zoneRad1_Callback(hObject, eventdata, handles)
global Exp
 
if get(handles.zoneRad1,'value')==0, set(handles.zoneRad1,'value',1); end
DexpN=get(handles.DN1,'value')
set(handles.zoneRad2,'value',0)
set(handles.zoneRad3,'value',0)
orfLstSel=get(handles.GeneOrfTog,'value')

if get(handles.GeneOrfTog,'value')==1
 set(handles.listboxGnOrf,'string',Exp(1).Dexp(DexpN).srtOrfLst)   %set(handles.listboxGnOrf,'string',Exp(1).srtOrfLst)   
else
   set(handles.listboxGnOrf,'string',Exp(1).Dexp(DexpN).srtGnLst)  %set(handles.listboxGnOrf,'string',Exp(1).srtGnLst)
end
if get(handles.zoneRad1,'value')==1 && get(handles.CompositeTog1,'value')==1
 set(handles.GeneOrfTog,'value',0) 
 set(handles.listboxGnOrf,'value',1)
 set(handles.listboxGnOrf,'string',Exp(1).Dexp(DexpN).srtGnLst)
 set(handles.CompositeTog1,'BackgroundColor',[1.0 0.6 0.6])   
 set(handles.CompositeTog1,'ForegroundColor',[1.0 0.0, 0.0])
else
    set(handles.CompositeTog1,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.CompositeTog1,'ForegroundColor',[0.0 0.0, 0.0])   
end

% --- Executes on button press in zoneRad2.
function zoneRad2_Callback(hObject, eventdata, handles)
global Exp

if get(handles.zoneRad2,'value')==0, set(handles.zoneRad2,'value',1); end
DexpN=get(handles.DN2,'value')
set(handles.zoneRad1,'value',0)
set(handles.zoneRad3,'value',0)

orfLstSel=get(handles.GeneOrfTog,'value')
if orfLstSel==1
 set(handles.listboxGnOrf,'string',Exp(2).Dexp(DexpN).srtOrfLst)   %set(handles.listboxGnOrf,'string',Exp(2).srtOrfLst)   
else
    set(handles.listboxGnOrf,'string',Exp(2).Dexp(DexpN).srtGnLst)  %set(handles.listboxGnOrf,'string',Exp(2).srtGnLst)
end

if get(handles.zoneRad2,'value')==1 && get(handles.CompositeTog2,'value')==1
 set(handles.GeneOrfTog,'value',0)    
 set(handles.listboxGnOrf,'value',1)  
 set(handles.listboxGnOrf,'string',Exp(2).Dexp(DexpN).srtGnLst)
 set(handles.CompositeTog2,'BackgroundColor',[1.0 0.6 0.6])   
 set(handles.CompositeTog2,'ForegroundColor',[1.0 0.0, 0.0])
else
    set(handles.CompositeTog2,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.CompositeTog2,'ForegroundColor',[0.0 0.0, 0.0])   
end


% --- Executes on button press in zoneRad3.
function zoneRad3_Callback(hObject, eventdata, handles)
global Exp

if get(handles.zoneRad3,'value')==0, set(handles.zoneRad3,'value',1); end
DexpN=get(handles.DN3,'value')
set(handles.zoneRad1,'value',0)
set(handles.zoneRad2,'value',0)
orfLstSel=get(handles.GeneOrfTog,'value')
if orfLstSel==1
 set(handles.listboxGnOrf,'string',Exp(3).Dexp(DexpN).srtOrfLst)   %set(handles.listboxGnOrf,'string',Exp(3).srtOrfLst)   
else
    set(handles.listboxGnOrf,'string',Exp(3).Dexp(DexpN).srtGnLst)  %set(handles.listboxGnOrf,'string',Exp(3).srtGnLst)
end

if get(handles.zoneRad3,'value')==1 && get(handles.CompositeTog3,'value')==1
 set(handles.GeneOrfTog,'value',0)   
 set(handles.listboxGnOrf,'value',1)  
 set(handles.listboxGnOrf,'string',Exp(3).Dexp(DexpN).srtGnLst)
 set(handles.CompositeTog3,'BackgroundColor',[1.0 0.6 0.6])   
 set(handles.CompositeTog3,'ForegroundColor',[1.0 0.0, 0.0])
else
    set(handles.CompositeTog3,'BackgroundColor',[1.0 0.8, 0.8])
    set(handles.CompositeTog3,'ForegroundColor',[0.0 0.0, 0.0])  
end
%}


% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
%function figure1_WindowButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable =='on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over printOL1.
function printOL1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to printOL1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
end

% --- Executes on key press with focus on printOL2 and none of its controls.
function printOL2_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to printOL2 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
end

% --- Executes on key press with focus on printOL3 and none of its controls.
function printOL3_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to printOL3 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
end
